    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56  import  org.apache.bcel.Constants;
    57  import org.apache.bcel.generic.Type;
    58  import java.io.*;
    59
    60  /***
    61   * This class represents the field info structure, i.e., the representation
    62   * for a variable in the class. See JVM specification for details.
    63   *
    64   * @version $Id: Field.java,v 1.3 2002/12/08 16:04:37 mdahm Exp $
    65   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    66   */
    67  public final class Field extends FieldOrMethod {
    68    /***
    69     * Initialize from another object. Note that both objects use the same
    70     * references (shallow copy). Use clone() for a physical copy.
    71     */
    72    public Field(Field c) {
    73      super(c);
    74    }
    75
    76    /***
    77     * Construct object from file stream.
    78     * @param file Input stream
    79     */
    80    Field(DataInputStream file, ConstantPool constant_pool)
    81         throws IOException, ClassFormatException
    82    {
    83      super(file, constant_pool);
    84    }
    85
    86    /***
    87     * @param access_flags Access rights of field
    88     * @param name_index Points to field name in constant pool
    89     * @param signature_index Points to encoded signature
    90     * @param attributes Collection of attributes
    91     * @param constant_pool Array of constants
    92     */
    93    public Field(int access_flags, int name_index, int signature_index,
    94  	       Attribute[] attributes, ConstantPool constant_pool)
    95    {
    96      super(access_flags, name_index, signature_index, attributes, constant_pool);
    97    }
    98
    99    /***
    100    * Called by objects that are traversing the nodes of the tree implicitely
    101    * defined by the contents of a Java class. I.e., the hierarchy of methods,
    102    * fields, attributes, etc. spawns a tree of objects.
    103    *
    104    * @param v Visitor object
    105    */
    106   public void accept(Visitor v) {
    107     v.visitField(this);
    108   }
    109
    110   /***
    111    * @return constant value associated with this field (may be null)
    112    */
    113   public final ConstantValue getConstantValue() {
    114     for(int i=0; i < attributes_count; i++)
    115       if(attributes[i].getTag() == Constants.ATTR_CONSTANT_VALUE)
    116 	return (ConstantValue)attributes[i];
    117
    118     return null;
    119   }
    120
    121   /***
    122    * Return string representation close to declaration format,
    123    * `public static final short MAX = 100', e.g..
    124    *
    125    * @return String representation of field, including the signature.
    126    */
    127   public final String toString() {
    128     String name, signature, access; // Short cuts to constant pool
    129
    130     // Get names from constant pool
    131     access    = Utility.accessToString(access_flags);
    132     access    = access.equals("")? "" : (access + " ");
    133     signature = Utility.signatureToString(getSignature());
    134     name      = getName();
    135
    136     StringBuffer  buf = new StringBuffer(access + signature + " " + name);
    137     ConstantValue cv  = getConstantValue();
    138
    139     if(cv != null)
    140       buf.append(" = " + cv);
    141
    142     for(int i=0; i < attributes_count; i++) {
    143       Attribute a = attributes[i];
    144
    145       if(!(a instanceof ConstantValue))
    146 	buf.append(" [" + a.toString() + "]");
    147     }
    148
    149     return buf.toString();
    150   }
    151
    152   /***
    153    * @return deep copy of this field
    154    */
    155   public final Field copy(ConstantPool constant_pool) {
    156     return (Field)copy_(constant_pool);
    157   }
    158
    159   /***
    160    * @return type of field
    161    */
    162   public Type getType() {
    163     return Type.getReturnType(getSignature());
    164   }
    165 }

This page was automatically generated by Maven